/**
    * @license
    * Copyright 2020 Google LLC. All Rights Reserved.
    * Licensed under the Apache License, Version 2.0 (the "License");
    * you may not use this file except in compliance with the License.
    * You may obtain a copy of the License at
    *
    * http://www.apache.org/licenses/LICENSE-2.0
    *
    * Unless required by applicable law or agreed to in writing, software
    * distributed under the License is distributed on an "AS IS" BASIS,
    * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
    * See the License for the specific language governing permissions and
    * limitations under the License.
    * =============================================================================
    */
import{slice,add,div,sub,mul,concat2d,tensor2d,tensor1d,tidy,sigmoid,image,Tensor,browser}from"@tensorflow/tfjs-core";import{loadGraphModel}from"@tensorflow/tfjs-converter";const disposeBox=s=>{s.startEndTensor.dispose(),s.startPoint.dispose(),s.endPoint.dispose()},createBox=s=>({startEndTensor:s,startPoint:slice(s,[0,0],[-1,2]),endPoint:slice(s,[0,2],[-1,2])}),scaleBox=(s,e)=>{const t=mul(s.startPoint,e),o=mul(s.endPoint,e),i=concat2d([t,o],1);return createBox(i)},ANCHORS_CONFIG={strides:[8,16],anchors:[2,6]},NUM_LANDMARKS=6;function generateAnchors(s,e,t){const o=[];for(let i=0;i<t.strides.length;i++){const a=t.strides[i],r=Math.floor((e+a-1)/a),n=Math.floor((s+a-1)/a),d=t.anchors[i];for(let s=0;s<r;s++){const e=a*(s+.5);for(let s=0;s<n;s++){const t=a*(s+.5);for(let s=0;s<d;s++)o.push([t,e])}}}return o}function decodeBounds(s,e,t){const o=slice(s,[0,1],[-1,2]),i=add(o,e),a=slice(s,[0,3],[-1,2]),r=div(a,t),n=div(i,t),d=div(r,2),c=sub(n,d),l=add(n,d),h=mul(c,t),p=mul(l,t);return concat2d([h,p],1)}class BlazeFaceModel{constructor(s,e,t,o,i,a){this.blazeFaceModel=s,this.width=e,this.height=t,this.maxFaces=o,this.anchorsData=generateAnchors(e,t,ANCHORS_CONFIG),this.anchors=tensor2d(this.anchorsData),this.inputSizeData=[e,t],this.inputSize=tensor1d([e,t]),this.iouThreshold=i,this.scoreThreshold=a}async getBoundingBoxes(s,e){const[t,o,i]=tidy(()=>{const e=s.resizeBilinear([this.width,this.height]),t=mul(sub(e.div(255),.5),2),o=this.blazeFaceModel.predict(t).squeeze(),i=decodeBounds(o,this.anchors,this.inputSize),a=slice(o,[0,0],[-1,1]);return[o,i,sigmoid(a).squeeze()]}),a=image.nonMaxSuppression(o,i,this.maxFaces,this.iouThreshold,this.scoreThreshold),r=await a.array();a.dispose();let n=r.map(s=>slice(o,[s,0],[1,-1]));e||(n=await Promise.all(n.map(async s=>{const e=await s.array();return s.dispose(),e})));const d=s.shape[1],c=s.shape[2];let l;l=e?div([c,d],this.inputSize):[c/this.inputSizeData[0],d/this.inputSizeData[1]];const h=n.map((s,o)=>tidy(()=>{const a=r[o];let n;return n=e?this.anchors.slice([a,0],[1,2]):this.anchorsData[a],{box:createBox(s instanceof Tensor?s:tensor2d(s)),landmarks:slice(t,[a,NUM_LANDMARKS-1],[1,-1]).squeeze().reshape([NUM_LANDMARKS,-1]),probability:slice(i,[a],[1]),anchor:n}}));return o.dispose(),i.dispose(),t.dispose(),[h,l]}async estimateFaces(s,e=!1){const t=tidy(()=>(s instanceof Tensor||(s=browser.fromPixels(s)),s.toFloat().expandDims(0))),[o,i]=await this.getBoundingBoxes(t,e);return t.dispose(),e?o.map(s=>{const e=scaleBox(s.box,i).startEndTensor.squeeze();return{topLeft:e.slice([0],[2]),bottomRight:e.slice([2],[2]),landmarks:s.landmarks.add(s.anchor).mul(i),probability:s.probability}}):Promise.all(o.map(async s=>{const e=tidy(()=>scaleBox(s.box,i).startEndTensor.squeeze()),[t,o,a]=await Promise.all([s.landmarks,e,s.probability].map(async s=>s.array())),r=s.anchor,n=t.map(s=>[(s[0]+r[0])*i[0],(s[1]+r[1])*i[1]]);return e.dispose(),disposeBox(s.box),s.landmarks.dispose(),s.probability.dispose(),{topLeft:o.slice(0,2),bottomRight:o.slice(2),landmarks:n,probability:a}}))}}const BLAZEFACE_MODEL_URL="https://tfhub.dev/tensorflow/tfjs-model/blazeface/1/default/1";async function load({maxFaces:s=10,inputWidth:e=128,inputHeight:t=128,iouThreshold:o=.3,scoreThreshold:i=.75}={}){const a=await loadGraphModel(BLAZEFACE_MODEL_URL,{fromTFHub:!0});return new BlazeFaceModel(a,e,t,s,o,i)}export{load};
